IMAP *imap=new IMAP(imaphost,imapuser,"sync4j");
	    sprintf(pb,"~%s/%s",users[i],cname);
	    
	    nmsg=imap->Select(pb);
	    {
	      // delete marked items
	      char emsg[1024];
	      int r=imap->Expunge(emsg);
	    }
	    
	    nmsg=imap->Select(pb);
	    if (LOGLEVEL>=1) {
	      LTS();
	      fprintf(LOGFILE,"IMAP-Folder ~%s/%s contains %d entries\n",users[i],cname,nmsg);
	      fflush(LOGFILE);
	    }
	    
	    char header[BSIZE];
	    char data[BSIZE];
	    char emsg1[BSIZE];
	    char emsg2[BSIZE];
	    char boundary[BSIZE];
	    
	    //--- scan IMAP folder and process items ---------------------------
	    for (int j=1;j<=nmsg;j++) {
	      int r1=imap->Fetch(j,"HEADER",header,emsg1);
	      int r2=imap->Fetch(j,"TEXT",data,emsg2);
	      
	      if (strstr(emsg2,"OK completed")==emsg2) {
		if (LOGLEVEL>=4) {
		  LTS();
		  fprintf(LOGFILE,header);
		  fprintf(LOGFILE,data);
		  fflush(LOGFILE);
		}
		
		IMAPItem *item=new IMAPItem(header,data);
		
		if ((strstr(data,"BEGIN:VCALENDAR")) && (strstr(data,"END:VCALENDAR"))) {
		  for (int ii=0;ii<item->NumParts();ii++) {
		    //-------------------------------------------------------------------------------------
		    if (strstr(item->Part(ii),"BEGIN:VCALENDAR")) {
		      char *aptr=strstr(item->Part(ii),"BEGIN:VCALENDAR");
		      char *eptr=strstr(aptr,"END:VCALENDAR");
		      unsigned long eblength=eptr-aptr+strlen("END:VCALENDAR");
		      char *ebuffer=new char [eblength+1];
		      memset(ebuffer,0,eblength+1);
		      strncpy(ebuffer,aptr,eblength);
		      
		      vCalendar *v=ParseCalendar(ebuffer);
		      
		      if ((v) && (v->NumEvents()==1)) {
			// store attachements to file-system
			char abdname[8192];
			if (GetValue("Application","Attachements"))
			  strcpy(abdname,GetValue("Application","Attachements"));
			else
			  strcpy(abdname,".");
			char abname[8192];
			sprintf(abname,"%s/%s.attachament.",abdname,v->Event(0)->UID());
			char cmd[8192];
			sprintf(cmd,"rm -f %s*",abname);
			system(cmd);
			for (int ia=0;ia<item->NumParts();ia++) {
			  if (ia!=ii) {
			    char aname[8192];
			    sprintf(aname,"%s%d",abname,ia);
			    item->WriteToFile(ia,aname);
			  }
			}
			// sync item
			long int r;
			r=SyncCalendarItem(imap,cname,j,db,users[i],v->Event(0),direction,"IMAP",folderid);
			// delete v;
		      } else {
			if (LOGLEVEL>=1) {
			  LTS();
			  fprintf(LOGFILE,"parser failed on\n%s\n",ebuffer);
			  fflush(LOGFILE);
			}
			
			// what to do, if parser failed
			char puid[2048];
			strcpy(puid,ParsedUID());
			if (strlen(puid)>0) {
			  // but we found an ID, touch the appropriate record with stouch=-1
			  // will indicate that the item is handled and should not be deleted!
			  sprintf(sql,"update fnbl_pim_calendar set stouch=-1 where suid='%s' and userid='%s'",puid,users[i]);
			  if (!db->SQL(sql)) {
			    if (LOGLEVEL>=1) {
			      LTS();
			      fprintf(LOGFILE,"failed to mark [%s] as handled\n   error is: %s\n",puid,db->Error());
			      fflush(LOGFILE);
			    }
			  }
			}
		      }
		      
		      delete ebuffer;
		    }
		  }
		}
		
		if (strstr(data,"BEGIN:VCARD")) {
		  for (int ii=0;ii<item->NumParts();ii++) {
		    //-------------------------------------------------------------------------------------
		    if (strstr(item->Part(ii),"BEGIN:VCARD")) {
		    }
		  }
		}
		
		if (item) delete item;
	      } // end of "OK completed"
	      
	    } // next message
	    
	    delete imap;
